## Ways of contributing

There are a few ways of contributing into the project:

1. Bug fixes
2. Check the [Issues page](https://github.com/alexstyl/MementoNamedays/issues) and resolve any issues you can find
3. Code refactor. The project is fairly old, so there is huge room for improvement :)
4. Introduce any interesting functionality you might need. Please do let me know before doing this first. There might be a chance that a feature you might want to include be really specific to your needs and not fit the overall style of the app. For any questions on features PR, email me at alexstyl.dev@gmail.com
5. Translate the app [by visiting OneSky](https://memento.oneskyapp.com/admin/project/dashboard/project/85177)

## Creating Pull Requests (PR)
The repo contains two main branches:

* `master` which contains all changes currently available to the Play Store.
* `develop` which contains all changes to be uploaded in the next version of Memento.

1. Create a branch from `develop`.
2. Make any modifications required.
3. When done, open a PR of that branch against develop.

Make sure to consider testing the code you push.

Do not create huge PRs. If a PR grows big, make sure to create a new branch with those changes, and create a PR against your initial `feature` branch. The bigger the PR, the less chances of it getting merged on time.

## Reporting Issues
In case you found a bug in the app, or some bits in the code base that can cause issues, you can open an Issue so that someone can fix it. If it is a bug, make sure to write down all the steps it took to replicate it and (if possible) add a GIF showcasing the bug.

You can record your screen with the help of Android Studio ([see this video](https://youtu.be/uOvL4TXzOm4?t=39s)). Keep in mind that video recording does not work on Emulators, so you will need a real device for that. After you are done recording, convert the video into a GIF. I usually use this [website (video to gif)](http://image.online-convert.com/convert-to-gif). Make sure to attach the GIF into your Issue :)
